"""empty message

Revision ID: 769c010b9d15
Revises: 1a3ff138baff
Create Date: 2024-02-27 15:41:43.096701

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = '769c010b9d15'
down_revision = '1a3ff138baff'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('company_contact',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('company_id', sa.Integer(), nullable=True),
    sa.Column('first_name', sa.String(), nullable=False),
    sa.Column('last_name', sa.String(), nullable=False),
    sa.Column('role', sa.String(), nullable=False),
    sa.Column('email', sa.String(), nullable=False),
    sa.Column('phone', sa.String(), nullable=True),
    sa.Column('student_visible', sa.Boolean(), nullable=False),
    sa.Column('safari_messages', sa.Boolean(), nullable=False),
    sa.ForeignKeyConstraint(['company_id'], ['company.id'], name=op.f('fk_company_contact_company_id_company')),
    sa.PrimaryKeyConstraint('id', name=op.f('pk_company_contact'))
    )
    op.create_table('safari_offer',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('company_id', sa.Integer(), nullable=False),
    sa.Column('safari_id', sa.Integer(), nullable=False),
    sa.Column('spots', sa.Integer(), nullable=False),
    sa.Column('use_alt_day', sa.Boolean(), nullable=False),
    sa.Column('contact_person', sa.String(), nullable=False),
    sa.Column('contact_person_info', sa.String(), nullable=False),
    sa.Column('extra_information', sa.String(), nullable=False),
    sa.ForeignKeyConstraint(['company_id'], ['company.id'], name=op.f('fk_safari_offer_company_id_company')),
    sa.ForeignKeyConstraint(['safari_id'], ['safari.id'], name=op.f('fk_safari_offer_safari_id_safari')),
    sa.PrimaryKeyConstraint('id', name=op.f('pk_safari_offer'))
    )
    op.create_table('safari_offer_students',
    sa.Column('safari_offer_id', sa.Integer(), nullable=True),
    sa.Column('student_id', sa.Integer(), nullable=True),
    sa.ForeignKeyConstraint(['safari_offer_id'], ['safari_offer.id'], name=op.f('fk_safari_offer_students_safari_offer_id_safari_offer')),
    sa.ForeignKeyConstraint(['student_id'], ['user.id'], name=op.f('fk_safari_offer_students_student_id_user')),
    info={'bind_key': None}
    )

    op.alter_column('company', 'location', new_column_name='city', type_=sa.String(), existing_type=sa.VARCHAR())
    op.drop_column('company', 'size')
    op.add_column('company', sa.Column('logo_includes_name', sa.Boolean(), nullable=False, server_default='false'))
    op.add_column('company', sa.Column('background_color', sa.String(), nullable=False, server_default='#ffffff'))
    op.add_column('company', sa.Column('foreground_color', sa.String(), nullable=False, server_default='#000000'))
    op.add_column('company', sa.Column('address', sa.String(), nullable=True))
    op.add_column('company', sa.Column('size', sa.Integer(), nullable=True))
    op.add_column('company', sa.Column('developers', sa.Integer(), nullable=True))
    op.add_column('company', sa.Column('technologies', sa.String(), nullable=True))
    op.add_column('company', sa.Column('intern_welcome', sa.Boolean(), nullable=False, server_default='true'))
    op.add_column('company', sa.Column('english_welcome', sa.Boolean(), nullable=False, server_default='false'))
    op.add_column('company', sa.Column('intern_apply', sa.String(), nullable=True))
    op.add_column('company', sa.Column('company_publish', sa.Boolean(), nullable=False, server_default='true'))
    op.add_column('company', sa.Column('teacher_publish', sa.Boolean(), nullable=False, server_default='true'))

    op.execute("""
    update company
    set technologies = techs.combined
    from (
        select company_id, string_agg(technologies, E'\n') combined
        from team
        group by company_id
    ) techs
    where techs.company_id = company.id
    """)

    op.drop_table('team')
    op.drop_table('safari_company_day_students')
    op.drop_table('safari_company_day')
    op.drop_table('safari_company')
    op.drop_column('company', 'misc')
    op.drop_column('company', 'login')
    op.drop_column('company', 'is_visible')
    op.alter_column('safari', 'second_date',
               existing_type=sa.DATE(),
               nullable=False)
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.alter_column('safari', 'second_date',
               existing_type=sa.DATE(),
               nullable=True)
    op.add_column('company', sa.Column('is_visible', sa.BOOLEAN(), autoincrement=False, nullable=True))
    op.add_column('company', sa.Column('location', sa.VARCHAR(), autoincrement=False, nullable=True))
    op.add_column('company', sa.Column('login', sa.VARCHAR(), server_default=sa.text("''::character varying"), autoincrement=False, nullable=False))
    op.add_column('company', sa.Column('misc', sa.VARCHAR(), autoincrement=False, nullable=True))
    op.alter_column('company', 'size',
               existing_type=sa.Integer(),
               type_=sa.VARCHAR(),
               existing_nullable=True)
    op.drop_column('company', 'teacher_publish')
    op.drop_column('company', 'company_publish')
    op.drop_column('company', 'intern_apply')
    op.drop_column('company', 'english_welcome')
    op.drop_column('company', 'intern_welcome')
    op.drop_column('company', 'technologies')
    op.drop_column('company', 'developers')
    op.drop_column('company', 'address')
    op.drop_column('company', 'city')
    op.drop_column('company', 'foreground_color')
    op.drop_column('company', 'background_color')
    op.drop_column('company', 'logo_includes_name')
    op.create_table('safari_company',
    sa.Column('id', sa.INTEGER(), server_default=sa.text("nextval('safari_company_id_seq'::regclass)"), autoincrement=True, nullable=False),
    sa.Column('contact_person', sa.VARCHAR(), autoincrement=False, nullable=False),
    sa.Column('contact_person_info', sa.VARCHAR(), autoincrement=False, nullable=False),
    sa.Column('extra_information', sa.VARCHAR(), autoincrement=False, nullable=True),
    sa.Column('company_id', sa.INTEGER(), autoincrement=False, nullable=True),
    sa.Column('safari_id', sa.INTEGER(), autoincrement=False, nullable=True),
    sa.ForeignKeyConstraint(['company_id'], ['company.id'], name='fk_safari_company_company_id_company'),
    sa.ForeignKeyConstraint(['safari_id'], ['safari.id'], name='fk_safari_company_safari_id_safari'),
    sa.PrimaryKeyConstraint('id', name='pk_safari_company'),
    postgresql_ignore_search_path=False
    )
    op.create_table('safari_company_day_students',
    sa.Column('safari_company_day_id', sa.INTEGER(), autoincrement=False, nullable=True),
    sa.Column('user_id', sa.INTEGER(), autoincrement=False, nullable=True),
    sa.ForeignKeyConstraint(['safari_company_day_id'], ['safari_company_day.id'], name='fk_safari_company_day_students_safari_company_day_id_sa_70db'),
    sa.ForeignKeyConstraint(['user_id'], ['user.id'], name='fk_safari_company_day_students_user_id_user')
    )
    op.create_table('safari_company_day',
    sa.Column('id', sa.INTEGER(), autoincrement=True, nullable=False),
    sa.Column('number_of_students', sa.INTEGER(), autoincrement=False, nullable=False),
    sa.Column('date', sa.DATE(), autoincrement=False, nullable=False),
    sa.Column('safari_company_id', sa.INTEGER(), autoincrement=False, nullable=True),
    sa.ForeignKeyConstraint(['safari_company_id'], ['safari_company.id'], name='fk_safari_company_day_safari_company_id_safari_company'),
    sa.PrimaryKeyConstraint('id', name='pk_safari_company_day')
    )
    op.create_table('team',
    sa.Column('id', sa.INTEGER(), autoincrement=True, nullable=False),
    sa.Column('name', sa.VARCHAR(), autoincrement=False, nullable=False),
    sa.Column('availability', sa.INTEGER(), autoincrement=False, nullable=False),
    sa.Column('size', sa.VARCHAR(), autoincrement=False, nullable=False),
    sa.Column('location', sa.VARCHAR(), autoincrement=False, nullable=False),
    sa.Column('technologies', sa.VARCHAR(), autoincrement=False, nullable=False),
    sa.Column('working_on', sa.VARCHAR(), autoincrement=False, nullable=True),
    sa.Column('misc', sa.VARCHAR(), autoincrement=False, nullable=True),
    sa.Column('contact', sa.VARCHAR(), autoincrement=False, nullable=False),
    sa.Column('company_id', sa.INTEGER(), autoincrement=False, nullable=True),
    sa.Column('dutch_only', sa.BOOLEAN(), autoincrement=False, nullable=True),
    sa.ForeignKeyConstraint(['company_id'], ['company.id'], name='fk_team_company_id_company'),
    sa.PrimaryKeyConstraint('id', name='pk_team')
    )
    op.drop_table('safari_offer_students')
    op.drop_table('safari_offer')
    op.drop_table('company_contact')
    # ### end Alembic commands ###
